<?php
require_once( ABSPATH . 'wp-config.php' );
//------------------------- Database ---------------------------------*/

$app['database_host']     = DB_HOST;
$app['database_user']     = DB_USER;
$app['database_password'] = DB_PASSWORD;
$app['database_name']     = DB_NAME;

//------------------------- Register settings, sections and fields --------------*/
$app['register-settings-section-fields'] = array(

    'register-settings' => array(
        array(
            'option_group' => 'wdoo_vote_first_tab_settings_group',//option group
            'option_name' => 'wdoo_vote_first_tab_settings',//option name - use to get values
            'callback' => 'wdoo_vote_first_tab_sanitize',//optional
            'add_setting_section' => array(
                array(
                    'section_id' => 'wdoo_vote_main_settings_section',//for string tags
                    'section_title' => 'Votes',//title of section
                    'section_callback' => 'wdoo_vote_first_tab_settings_section_cb',//function/method that fills the section with content
                    'section_registered_option_name' => 'wdoo_vote_first_tab_settings',//the page or option_name to show the section
                ),
            ),
        ),//end register setting

    )//end register-settings

);//register-settings-section-fields

//------------------------- Options Page Tab Titles ---------------------------------*/
$app['config-set-tab-page-titles'] =  array(

    'title'     => 'Webberdoo Vote',
    'first_tab_title'     => 'Nominees',

    'activate_second_tab_title'   => true,
    'second_tab_title'          => 'Voters',

    'activate_third_tab_title'   => false,
    'third_tab_title'          => '',

    'activate_fourth_tab_title'   => false,
    'fourth_tab_title'          => '',

    'activate_fifth_tab_title'   => false,
    'fifth_tab_title'          => '',
);

//------------------------- CUSTOM POST TYPES ---------------------------------*/
$app['config-posttypes'] = array(

    'post_type' => array(
        array(
            'custom_post_type_name' => 'wdoo_btc_donate',

            'single_name'           => 'Bitcoin Donate',
            'plural_name'           => 'Bitcoin Donates',
            'menu_position'         => 2,
           // 'show_in_rest'          => true,
            'supports'              => array('title'),//'title', 'editor', 'thumbnai'
            'public'                => false,  // if it's not public, it shouldn't have it's own permalink, and so on
            'publicly_queryable'    => true,  // you should be able to query it
            'show_ui'               => true,  // you should be able to edit it in wp-admin
            'exclude_from_search'   => true,  // if you want no permalink, you should exclude it from search results
            'show_in_nav_menus'     => false,  // if you want no permalink, you shouldn't be able to add it to menus
            'has_archive'           => false,  // if you want no permalink, it shouldn't have archive page
            'rewrite'               => false,  // if you want no permalink, it shouldn't have rewrite rules else: array( 'slug' => $value['custom_post_type_name'] )
            'create_posts'          => 'create_posts',

        ),//end array#


    ),//end post_type
);//end config-posttypes


/**]
 *
 * No capabilities - Add New, Edit, Delete
 */
$app['config-posttypes_no_capabilities'] = array(

	'post_type' => array(
		array(
			'custom_post_type_name' => 'web_voter_emails',
			'menu_position'         => 2,
			'single_name'           => 'Votr Email',
			'plural_name'           => 'Votr Emails',
			'supports'              => array('title'),//'title', 'editor', 'thumbnai'
			'public'                => false,  // if it's not public, it shouldn't have it's own permalink, and so on
			'publicly_queryable'    => true,  // you should be able to query it
			'show_ui'               => true,  // you should be able to edit it in wp-admin
			'exclude_from_search'   => true,  // if you want no permalink, you should exclude it from search results
			'show_in_nav_menus'     => false,  // if you want no permalink, you shouldn't be able to add it to menus
			'has_archive'           => false,  // if you want no permalink, it shouldn't have archive page
			'rewrite'               => false,  // if you want no permalink, it shouldn't have rewrite rules else: array( 'slug' => $value['custom_post_type_name'] )
		),//end array#

	),//end post_type
);//end config-posttypes
