<?php
namespace Webberdoo\BTC\App\Providers;


use Webberdoo\BTC\App\Lib\WdooPostTypes;
use Silex\Application;
use Pimple\ServiceProviderInterface;
use Symfony\Component\HttpFoundation\Request;
use Webberdoo\BTC\AppBundle\Controllers\AcfController;
use Webberdoo\BTC\AppBundle\Controllers\EnqueueController;
use Webberdoo\BTC\AppBundle\Controllers\OptionController;
use Webberdoo\BTC\AppBundle\Controllers\ShortcodeController;
use Pimple\Container;

use Webberdoo\BTC\AppBundle\Views\Front\Shortcodes\BTCShortcode;
use Webberdoo\BTC\AppBundle\Views\Front\Shortcodes\Inc\GlobalSyles;
use Webberdoo\BTC\AppBundle\Widgets\BTCWidget;

/**
 * Class CustomServiceProvider
 *
 * @package Webberdoo\MC\App\Providers
 */
class CustomServiceProvider implements ServiceProviderInterface
{
    /**
     * Register Classes into silex container
     *
     * @param Application $app
     */
    public function register(Container $app)
    {
        $app['shortcode'] = function () use ($app){

            return new ShortcodeController($app);
        };


        $app['wdoo-post-types'] = function () use ($app) {

            return new WdooPostTypes($app);
        };

        $app['request'] = function () {
            return new Request();

        };

        $app['options-page'] = function () use ($app){
            return new OptionController($app);

        };

        $app['enqueue'] = function (){
            return new EnqueueController();

        };


        $app['acf-controller'] = function () {
            return new AcfController();

        };

	    $app['btc-shortcode-front-view'] = function () use ($app) {
		    return new BTCShortcode($app);

	    };

	    $app['global-styles-view-inc'] = function () {
		    return new GlobalSyles();

	    };

	    $app['btc-widget'] = function () {
		    return new BTCWidget();

	    };

    }

    /**
     * @param Application $app
     */
    public function boot(Application $app)
    {

    }
}
