<?php
/**
 * Created by PhpStorm.
 * User: freddie
 * Date: 20/02/2016
 * Time: 07:55
 */

namespace Webberdoo\BTC\AppBundle\Controllers;


use DateTime;use DateTimeZone;use Silex\Application;
use Symfony\Component\HttpFoundation\Request;
use Webberdoo\BTC\AppBundle\Entity\Category;
use Webberdoo\BTC\AppBundle\Entity\WdooVoter;
use WP_Query;

/**
 * Class ShortcodeController
 * @package Webberdoo\BTC\AppBundle\Controllers
 */
class ShortcodeController
{
    /**
     * @var Application
     */
    public $app;
    public $vote_count;

    /**
     * @param Application $app
     */
    function __construct(Application $app)
    {
        $this->app = $app;
    }


    /**
     *Imitilize
     */
    public function init()
    {
        add_shortcode('webberdoo-btc-donate', array($this, 'wdoo_shortcode'));

        add_action( 'wp_enqueue_scripts', [$this,'wdoo_shortcode_wp_enqueue_scripts'] );
    }

    /**
     * Register css for shortcodes
     */
    public function wdoo_shortcode_wp_enqueue_scripts() {

        wp_register_style('webberdoo-custom_grid', plugins_url('/bitcoindonate/assets/css/grid.min.css'));
	    wp_register_style('webberdoo-foundation_grid', plugins_url('/bitcoindonate/assets/css/foundation.css'));
	    wp_register_style('webberdoo-app_widget', plugins_url('/bitcoindonate/assets/css/app_widget.css'));

        //js
        wp_register_script('wdoo_vue', plugins_url('/bitcoindonate/assets/js/vue.min.js'),[], '4.0', true);
	    wp_register_script('wdoo_app', plugins_url('/bitcoindonate/assets/js/app.js'), [], '', true);
	 }

    /**
     * @param $atts
     * @param null $content
     */

	public function wdoo_shortcode($atts, $content = null)
	{
		wp_enqueue_style('webberdoo-foundation_grid');

		wp_enqueue_script( 'wdoo_vue');
		wp_enqueue_script( 'wdoo_app');

		$atts = shortcode_atts(
			[
				'id' => ''
			], $atts
		);

		$post_id = $atts['id'];

		$args = array(
			'post_type' => 'wdoo_btc_donate',
			'p' => $post_id,
		);

		$loop = new WP_Query($args);

		return $this->app['btc-shortcode-front-view']->render($loop, $post_id);
	}



}