<?php
/**
 * Created by PhpStorm.
 * User: fredd
 * Date: 03/05/2017
 * Time: 06:42
 */

namespace Webberdoo\BTC\AppBundle\Views\Front\Shortcodes;

use Silex\Application;
use DateTime;
use DateTimeZone;
use SimpleXMLElement;

class BTCShortcode
{
     private $app;

    function __construct(Application $app)
    {

        $this->app = $app;
    }



    public function render($loop, $post_id)
    {
        $content_before = get_field('content_before', $post_id);
        $content_after = get_field('content_after', $post_id);
        $rend_content_before = '<div class="row"><div class="small-12 columns">'.$content_before.'</div></div>';
        $rend_content_after = '<div class="row"><div class="small-12 columns">'.$content_after.'</div></div>';

        //styles
        $background_colour = get_field('background_colour_g', $post_id);
        $background_padding_g = get_field('background_padding_g', $post_id).'px';
        $border_style_gallery = get_field('border_style_gallery', $post_id);
        $border_width_gallery = get_field('border_width_gallery', $post_id).'px';
        $border_colour_gallery = get_field('border_colour_gallery', $post_id);


        $this->app['global-styles-view-inc']->render($post_id);

        /********************************************************************************************/
        $content = '';

        $content .='<div class="row">';
        $content .='<div class="small-12 columns">';
         $content .="<div style=' word-wrap: break-word; width: 100%; background-color: $background_colour; padding: $background_padding_g;border-style: $border_style_gallery;border-width: $border_width_gallery; border-color: $border_colour_gallery;'>";

            if($loop->have_posts()){
                while ($loop->have_posts()){
                    $loop->the_post();

	                $btc_address = get_field('field_59c27a4cbf78a', $post_id);
	                if(!empty($btc_address)) {


		                //blochchain.info
		                $blcInfo = "http://blockchain.info/address/$btc_address?format=json";
		                $getBlcInfo      = $this->wp_curl($blcInfo);

		                $totalRecived    = $getBlcInfo->total_received;
		                $totalRecivedBtc = $totalRecived / 100000000;

		                //coinmarketcap get bitcoin price
		                $btcPriceUrl   = 'https://api.coinmarketcap.com/v1/ticker/bitcoin/?convert='.get_field('field_59c27a63bf78b', $post_id);//currency
		                $btcPrice      = $this->wp_curl($btcPriceUrl);

		                $totalBtcInUSD = $totalRecivedBtc * $this->currencyBtcPrice($btcPrice, $post_id);
		                $getBtcInUSD   = number_format( $totalBtcInUSD, 2, '.', '' );


		                /*********************************************** BUILD CONTENT *********************************************/

		                //TEXT
		                $total = get_field('field_59c4e930f8b8f', 'options');
		                $btc_to_send = get_field('field_59c4e95af8b90', 'options');
		                $send_btc_to = get_field('field_59c4e986f8b91', 'options');
		                $btc_so_far = get_field('field_59c4e9bff8b92', 'options');
		                $btc_conversion = get_field('field_59c81ad421d4f', 'options');
		                $address = get_field('field_59c81bb3f80ee', 'options');
		                $most_recent_trans = get_field('field_59c81b45f80ed', 'options');
		                $btc_sent_from = get_field('field_59c81e1153855', 'options');


		                $content .= '<div class="row">';
		                $content .= '<div class="wdoo-box" id="wdoo-app">';
		                $content .= '<div id="wdoo-app">';

		                $content .= '
                                      <div class="row"><div class="small-12 medium-3 large-3 columns wdoo-center-qrc">
                                           <img v-bind:src="qrCode" >
                                      </div>
                                      <div class="small-12 medium-5 large-5 columns wdoo-center-btc">';

	                    $content .= " <div class='row'>
	                                    <div class='small-12 medium-9 large-9 columns'>
	                                        <label for='total'>
	                                           <div class='total_text'>".sprintf(esc_html__('%s', 'bitcoindonate'), $total)." " .get_field('field_59c27a63bf78b', $post_id).":</div>
										       <input type='text' id='sendBtc' @keyup='sendBtc' v-model='btc'>
										    </label>
										    <label for='btc'>
										      <div class='total_text'>".sprintf(esc_html__('%s', 'bitcoindonate'), $btc_to_send).":</div>
										      <div class='btcToSend' v-cloak>{{ btcToSend }}</div>
										    </label>
									    </div>
								        </div>";
		                $content .= "   <div class='send_amount'>".sprintf(esc_html__('%s', 'bitcoindonate'), $send_btc_to).": </div><div class='btc_address'>" . $btc_address . "</div>
									 
                                      </div>";
                       if(get_field('field_59c4c22f4f6f2', $post_id)) {//show total donations
                       $content .= '   <div class="small-12 medium-4 large-4 columns">
	                                      <br><div class="total_btc_title">'.sprintf(esc_html__("%s", "bitcoindonate"), $btc_so_far).':</div>
									       <span class="total_btc"> '.esc_html__("BTC", "bitcoindonate").': ' . $totalRecivedBtc . '</span>
									       <br><div class="total_currency">'.sprintf(esc_html__("%s", "bitcoindonate"), $btc_conversion).': ' . number_format($getBtcInUSD,2,'.',',') . ' ' . get_field( 'field_59c27a63bf78b', $post_id ) . '</div>
	                                   </div>';
                       }
		                $content .= '</div>';
		                $content .= '</div>';

                       if(get_field('field_59c27c789893d',$post_id)) //if show most recent donations is true number_format($number, 2, '.', ',')
                       {
	                       /************ most recent transactions **************/
	                       $content .= ' <hr class="wdoo">';

	                       $content .= '<p class="recent_title">'.sprintf(esc_html__("%s", "bitcoindonate"), $most_recent_trans).'</p>';

	                       $content .= '<table class="stack">
									  <thead>
									    <tr>
									      <th width="200">'.esc_html__("BTC", "bitcoindonate").'</th>
									      <th width="150">'.sprintf(esc_html__("%s", "bitcoindonate"), $address).'</th>
									    </tr>
									  </thead>
									  <tbody>';
	                       foreach ( $getBlcInfo->txs as $trans ) {
		                       $recivedFromAddress = $trans->inputs[0]->prev_out->addr;
		                       $recivedFromAmount  = $trans->out[0]->value;

		                       $recFromAmountBtc = $recivedFromAmount / 100000000;

		                       $content .= '<tr>
													      <td>' . $recFromAmountBtc . '</td>
													      <td> '.sprintf(esc_html__("%s", "bitcoindonate"), $btc_sent_from).' <a href ="https://blockchain.info/address/' . $recivedFromAddress . '" target="_blank" >' . $recivedFromAddress . '</a></td>
													    </tr>';
	                       }
	                       $content .= '</tbody>
								    </table>';
	                       /************ end most recent transactions **************/
                       }

		             //  $content .= '</div>';
		                $content .= '
		                     <script>
		                     var btcPrice = "'.$this->currencyBtcPrice($btcPrice, $post_id).'";
		                     var btc_address = "'.$btc_address.'";
                             </script>
		                ';


	                }else{
		                $content .=''. esc_html__("No Bitcoin donations accepted yet.", "bitcoindonate").'';
	                }//end if btc_address
                }//end while
                wp_reset_postdata();
            }//end if


	    $content .="</div>";//END STYLE
        $content .="</div>";
	    $content .="</div>";//end wdoo app
	    $content .="</div>";//end wdoo box
        $content .="</div>";// END ROW

        /*********************************************** END BUILD CONTENT *********************************************/

        return $content;
    }

    private function currencyBtcPrice($btcPrice, $post_id)
    {
    	$currency = get_field('field_59c27a63bf78b', $post_id);//currency

	    switch ($currency) {
		    case 'GBP':
			    return $btcPrice[0]->price_gbp;;
			    break;
		    case 'USD':
			    return $btcPrice[0]->price_usd;
			    break;
		    case 'EUR':
			    return $btcPrice[0]->price_eur;
			    break;
		    case 'AUD':
			    return $btcPrice[0]->price_aud;
			    break;
		    case 'BRL':
			    return $btcPrice[0]->price_brl;
			    break;
		    case 'CAD':
			    return $btcPrice[0]->price_cad;
			    break;
		    case 'CHF':
			    return $btcPrice[0]->price_chf;
			    break;
		    case 'CLP':
			    return $btcPrice[0]->price_clp;
			    break;
		    case 'CNY':
			    return $btcPrice[0]->price_cny;
			    break;
		    case 'CZK':
			    return $btcPrice[0]->price_czk;
			    break;
		    case 'DKK':
			    return $btcPrice[0]->price_dkk;
			    break;
		    case 'HKD':
			    return $btcPrice[0]->price_hkd;
			    break;
		    case 'HUF':
			    return $btcPrice[0]->price_huf;
			    break;
		    case 'IDR':
			    return $btcPrice[0]->price_idr;
			    break;
		    case 'ILS':
			    return $btcPrice[0]->price_ils;
			    break;
		    case 'INR':
			    return $btcPrice[0]->price_inr;
			    break;
		    case 'JPY':
			    return $btcPrice[0]->price_jpy;
			    break;
		    case 'KRW':
			    return $btcPrice[0]->price_krw;
			    break;
		    case 'MXN':
			    return $btcPrice[0]->price_mxn;
			    break;
		    case 'MYR':
			    return $btcPrice[0]->price_myr;
			    break;
		    case 'NOK':
			    return $btcPrice[0]->price_nok;
			    break;
		    case 'NZD':
			    return $btcPrice[0]->price_nzd;
			    break;
		    case 'PHP':
			    return $btcPrice[0]->price_php;
			    break;
		    case 'PKR':
			    return $btcPrice[0]->price_pkr;
			    break;
		    case 'PLN':
			    return $btcPrice[0]->price_pln;
			    break;
		    case 'RUB':
			    return $btcPrice[0]->price_rub;
			    break;
		    case 'SEK':
			    return $btcPrice[0]->price_sek;
			    break;
		    case 'SGD':
			    return $btcPrice[0]->price_sgd;
			    break;
		    case 'THB':
			    return $btcPrice[0]->price_thb;
			    break;
		    case 'TRY':
			    return $btcPrice[0]->price_try;
			    break;
		    case 'TWD':
			    return $btcPrice[0]->price_twd;
			    break;
		    case 'ZAR':
			    return $btcPrice[0]->price_zar;
			    break;
		    default:
		    	return $btcPrice[0]->price_usd;
	    }
    }

    private function blockchainInfo()
    {

    }

	private function coinmarketcap()
	{

	}


    private function wp_curl($url)
    {
	    $header = array();
	  //  $header[] = 'Authorization: Bearer '.$this->envato_token;
	    $header[] = 'User-Agent: Mozilla/5.0 (Macintosh; Intel Mac OS X 10.11; rv:41.0) Gecko/20100101 Firefox/41.0';
	    $header[] = 'timeout: 20';
	    $curl = curl_init($url);
	    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($curl, CURLOPT_HTTPHEADER,$header);

	    $envatoRes = curl_exec($curl);
	    curl_close($curl);
	    $envatoRes = json_decode($envatoRes);

	    return $envatoRes;
    }




}