<?php
namespace Webberdoo\BTC\AppBundle\Widgets;

class BTCWidget extends \WP_Widget
{

	public function __construct()
	{
		$options = [
			'description' => 'Widget for Webberdoo Bitcion dote',
			'name' => 'Bitcoin Donate'

		];

		parent::__construct('BTCWidget', '',$options);

	}

	public function form($instance)
	{//30 currencies
		extract($instance);
		?>

        <p>
            <label for="<?php echo $this->get_field_id('title') ?>">Title:</label>
            <input type="text" class="widefat" id="<?php echo $this->get_field_id('title') ?>"
                   name="<?php echo $this->get_field_name('title') ?>" value="<?php if(isset($title)) echo esc_attr($title); ?>">
        </p>

		<p>
			<label for="<?php echo $this->get_field_id('btc_address') ?>">Bitcoin Address:</label>
			<input type="text" class="widefat" id="<?php echo $this->get_field_id('btc_address') ?>"
			       name="<?php echo $this->get_field_name('btc_address') ?>" value="<?php if(isset($btc_address)) echo esc_attr($btc_address); ?>">
		</p>

        <p>
            <label for="<?php echo $this->get_field_id('currency') ?>">Currency</label>
            <select name="<?php echo $this->get_field_name('currency'); ?>" id="<?php echo $this->get_field_id('currency') ?>">
                <option <?php if ($currency == 'USD' ) echo 'selected' ; ?> value="USD">USD</option>
                <option <?php if ($currency == 'GBP' ) echo 'selected' ; ?> value="GBP">GBP</option>
                <option <?php if ($currency == 'EUR' ) echo 'selected' ; ?> value="EUR">EUR</option>
                <option <?php if ($currency == 'AUD' ) echo 'selected' ; ?> value="AUD">AUD</option>
                <option <?php if ($currency == 'BRL' ) echo 'selected' ; ?> value="BRL">BRL</option>
                <option <?php if ($currency == 'CAD' ) echo 'selected' ; ?> value="CAD">CAD</option>
                <option <?php if ($currency == 'CHF' ) echo 'selected' ; ?> value="CHF">CHF</option>
                <option <?php if ($currency == 'CLP' ) echo 'selected' ; ?> value="CLP">CLP</option>
                <option <?php if ($currency == 'CNY' ) echo 'selected' ; ?> value="CNY">CNY</option>
                <option <?php if ($currency == 'CZK' ) echo 'selected' ; ?> value="CZK">CZK</option>
                <option <?php if ($currency == 'DKK' ) echo 'selected' ; ?> value="DKK">DKK</option>
                <option <?php if ($currency == 'HKD' ) echo 'selected' ; ?> value="HKD">HKD</option>
                <option <?php if ($currency == 'HUF' ) echo 'selected' ; ?> value="HUF">HUF</option>
                <option <?php if ($currency == 'IDR' ) echo 'selected' ; ?> value="IDR">IDR</option>
                <option <?php if ($currency == 'JPY' ) echo 'selected' ; ?> value="JPY">JPY</option>
                <option <?php if ($currency == 'KRW' ) echo 'selected' ; ?> value="KRW">KRW</option>
                <option <?php if ($currency == 'MXN' ) echo 'selected' ; ?> value="MXN">MXN</option>
                <option <?php if ($currency == 'MYR' ) echo 'selected' ; ?> value="MYR">MYR</option>
                <option <?php if ($currency == 'NOK' ) echo 'selected' ; ?> value="NOK">NOK</option>
                <option <?php if ($currency == 'NZD' ) echo 'selected' ; ?> value="NZD">NZD</option>
                <option <?php if ($currency == 'PHP' ) echo 'selected' ; ?> value="PHP">PHP</option>
                <option <?php if ($currency == 'PKR' ) echo 'selected' ; ?> value="PKR">PKR</option>
                <option <?php if ($currency == 'PLN' ) echo 'selected' ; ?> value="PLN">PLN</option>
                <option <?php if ($currency == 'RUB' ) echo 'selected' ; ?> value="RUB">RUB</option>
                <option <?php if ($currency == 'SEK' ) echo 'selected' ; ?> value="SEK">SEK</option>
                <option <?php if ($currency == 'SGD' ) echo 'selected' ; ?> value="SGD">SGD</option>
                <option <?php if ($currency == 'THB' ) echo 'selected' ; ?> value="THB">THB</option>
                <option <?php if ($currency == 'TRY' ) echo 'selected' ; ?> value="TRY">TRY</option>
                <option <?php if ($currency == 'TWD' ) echo 'selected' ; ?> value="TWD">TWD</option>
                <option <?php if ($currency == 'ZAR' ) echo 'selected' ; ?> value="ZAR">ZAR</option>
            </select>
        </p>

        <?php

	}

	public function widget($args, $instance)
	{
		extract($args);
		extract($instance);

		wp_enqueue_script( 'wdoo_vue');
		wp_enqueue_script( 'wdoo_app');
		wp_enqueue_style( 'webberdoo-app_widget');

    	$data = $this->bitcoin($btc_address, $currency);

		$title = apply_filters('widget-title', $title);

    	echo $before_widget;
    	echo $before_title . $title .  $after_title;
		echo $data;
		echo $after_widget;

	}

	private function bitcoin($btc_address, $currency)
	{
		if(empty($btc_address))
		{
			return false;
		}

		return $this->fetch_blochchainInfo($btc_address, $currency);

	}


	private function fetch_blochchainInfo($btc_address, $currency)
	{

		$btcPriceUrl   = 'https://api.coinmarketcap.com/v1/ticker/bitcoin/?convert='.$currency;
		$btcPriceWidget = $this->wp_curl($btcPriceUrl);

		//TEXT
		$btc_to_send = get_field('field_59c81d6f039e1', 'options');
		$total = get_field('field_59c81d60039e0', 'options');
		$send_btc_to = get_field('field_59c81d8d039e2', 'options');

		$wc = '';
		$wc .= '<div id="wdoo-app-widget" class="wdoo-widget">';
		        $wc .= '<div class="wdoo-center-qrc-widget"><img v-bind:src="qrCodeWidget"></div>';
                $wc .= " <div class='sub_heading_total'>".sprintf(esc_html__('%s', 'bitcoindonate'), $total)." " .$currency.":</div>
                            <input type='text' id='sendBtcWidget' @keyup='sendBtcWidget' v-model='btcWidget' class='wdoo-widget'>";
                $wc .= "<div class='sub_heading'>".sprintf(esc_html__('%s', 'bitcoindonate'), $btc_to_send).":</div>
                            <div v-cloak>{{ btcToSendWidget }}</div>";
                $wc .= "<div class='sub_heading'>".sprintf(esc_html__('%s', 'bitcoindonate'), $send_btc_to).": </div><div>" . $btc_address . "</div>";
                $wc .= '
                         <script>
                             var btcPriceWidget = "'.$this->currencyBtcPriceWidget($btcPriceWidget, $currency).'";
                             var btc_address = "'.$btc_address.'";
                         </script>
                    ';
		$wc .= '</div>';
		return $wc;
	}

	private function currencyBtcPriceWidget($btcPrice, $currency)
	{

		switch ($currency) {
			case 'GBP':
				return $btcPrice[0]->price_gbp;;
				break;
			case 'USD':
				return $btcPrice[0]->price_usd;
				break;
			case 'EUR':
				return $btcPrice[0]->price_eur;
				break;
			case 'AUD':
				return $btcPrice[0]->price_aud;
				break;
			case 'BRL':
				return $btcPrice[0]->price_brl;
				break;
			case 'CAD':
				return $btcPrice[0]->price_cad;
				break;
			case 'CHF':
				return $btcPrice[0]->price_chf;
				break;
			case 'CLP':
				return $btcPrice[0]->price_clp;
				break;
			case 'CNY':
				return $btcPrice[0]->price_cny;
				break;
			case 'CZK':
				return $btcPrice[0]->price_czk;
				break;
			case 'DKK':
				return $btcPrice[0]->price_dkk;
				break;
			case 'HKD':
				return $btcPrice[0]->price_hkd;
				break;
			case 'HUF':
				return $btcPrice[0]->price_huf;
				break;
			case 'IDR':
				return $btcPrice[0]->price_idr;
				break;
			case 'ILS':
				return $btcPrice[0]->price_ils;
				break;
			case 'INR':
				return $btcPrice[0]->price_inr;
				break;
			case 'JPY':
				return $btcPrice[0]->price_jpy;
				break;
			case 'KRW':
				return $btcPrice[0]->price_krw;
				break;
			case 'MXN':
				return $btcPrice[0]->price_mxn;
				break;
			case 'MYR':
				return $btcPrice[0]->price_myr;
				break;
			case 'NOK':
				return $btcPrice[0]->price_nok;
				break;
			case 'NZD':
				return $btcPrice[0]->price_nzd;
				break;
			case 'PHP':
				return $btcPrice[0]->price_php;
				break;
			case 'PKR':
				return $btcPrice[0]->price_pkr;
				break;
			case 'PLN':
				return $btcPrice[0]->price_pln;
				break;
			case 'RUB':
				return $btcPrice[0]->price_rub;
				break;
			case 'SEK':
				return $btcPrice[0]->price_sek;
				break;
			case 'SGD':
				return $btcPrice[0]->price_sgd;
				break;
			case 'THB':
				return $btcPrice[0]->price_thb;
				break;
			case 'TRY':
				return $btcPrice[0]->price_try;
				break;
			case 'TWD':
				return $btcPrice[0]->price_twd;
				break;
			case 'ZAR':
				return $btcPrice[0]->price_zar;
				break;
			default:
				return $btcPrice[0]->price_usd;
		}
	}


	private function wp_curl($url)
	{
		$header = array();
		//  $header[] = 'Authorization: Bearer '.$this->envato_token;
		$header[] = 'User-Agent: Mozilla/5.0 (Macintosh; Intel Mac OS X 10.11; rv:41.0) Gecko/20100101 Firefox/41.0';
		$header[] = 'timeout: 20';
		$curl = curl_init($url);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_HTTPHEADER,$header);

		$envatoRes = curl_exec($curl);
		curl_close($curl);
		$envatoRes = json_decode($envatoRes);

		return $envatoRes;
	}
}


add_action('widgets_init', function (){
	register_widget('Webberdoo\BTC\AppBundle\Widgets\BTCWidget');
});